%global debug_package %{nil}
%global _soversion %%(echo %{version} | awk -F. '{printf "%d.%d.0", $1, $2}')

%bcond_with emacs

Summary:          Utilities and example programs for use with XDP
Name:             xdp-tools
Version:          1.4.2
Release:          3%{?dist}

License:          GPLv2
URL:              https://github.com/xdp-project/%{name}
Source0:          https://github.com/xdp-project/%{name}/releases/download/v%{version}/xdp-tools-%{version}.tar.gz

BuildRequires: make gcc pkgconfig m4
BuildRequires: libbpf-devel elfutils-libelf-devel zlib-devel libpcap-devel clang >= 10.0.0 llvm >= 10.0.0 bpftool
BuildRequires: wireshark-cli
%if %{with emacs}
BuildRequires: emacs-nox
%endif

Requires:         libxdp = %{version}-%{release}

%description
Utilities and example programs for use with XDP

%package -n libxdp
Summary:          XDP helper library
Requires:         kernel-headers

%package -n libxdp-devel
Summary:          Development files for libxdp
Requires:         kernel-headers
Requires:         libxdp = %{version}-%{release}

%package -n libxdp-static
Summary:          Static library files for libxdp
Requires:         kernel-headers
Requires:         libxdp-devel = %{version}-%{release}

%description -n libxdp
The libxdp package contains the libxdp library for managing XDP programs,
used by the %{name} package

%description -n libxdp-devel
The libxdp-devel package contains headers used for building XDP programs using
libxdp.

%description -n libxdp-static
The libxdp-static package contains the static library version of libxdp.

%prep
%autosetup -p1 -n %{name}-%{version}


%build
export LIBDIR='%{_libdir}'
export RUNDIR='%{_rundir}'
export CLANG=%{_bindir}/clang
export LLC=%{_bindir}/llc
export PRODUCTION=1
export DYNAMIC_LIBXDP=1
export FORCE_SYSTEM_LIBBPF=1
%if %{with emacs}
export FORCE_EMACS=1
%endif
./configure
%make_build

%install
export SBINDIR='%{_sbindir}'
export LIBDIR='%{_libdir}'
export RUNDIR='%{_rundir}'
export MANDIR='%{_mandir}'
export DATADIR='%{_datadir}'
export HDRDIR='%{_includedir}/xdp'
%make_install

%files
%license LICENSES/*
%{_sbindir}/xdp-filter
%{_sbindir}/xdp-loader
%{_sbindir}/xdpdump
%{_sbindir}/xdp-bench
%{_sbindir}/xdp-monitor
%{_sbindir}/xdp-trafficgen
%{_libdir}/bpf/xdpfilt_*.o
%{_libdir}/bpf/xdpdump_*.o
%{_datadir}/xdp-tools/
%{_mandir}/man8/*

%files -n libxdp
%license LICENSES/*
%{_libdir}/libxdp.so.1
%{_libdir}/libxdp.so.%{_soversion}
%{_libdir}/bpf/xdp-dispatcher.o
%{_libdir}/bpf/xsk_def_xdp_prog*.o
%{_mandir}/man3/*

%files -n libxdp-static
%{_libdir}/libxdp.a

%files -n libxdp-devel
%{_includedir}/xdp/*.h
%{_libdir}/libxdp.so
%{_libdir}/pkgconfig/libxdp.pc

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.4.2-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.4.2-2
- Rebuilt for loongarch release

* Fri Feb 02 2024 Miaojun Dong <zoedong@ttencent.com> - 1.4.2-1
- Upgrade version to 1.4.2
- Rebuild for binutils-2.41-2 to fix BPF bytecode files strip failure
- Remove Patch for i686 arch

* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 1.3.1-3
- Rebuilt for llvm 17.0.6

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.1-2
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Jul 14 2023 Wang Guodong <gordonwwang@tencent.com> - 1.3.1-1
- Upgrade to 1.3.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.8-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.8-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 16 2023 cunshunxia <cunshunxia@tencent.com> - 1.2.8-1
- initial build
